#ifndef DEVICEDESCRIPTIONWIDGET_H
#define DEVICEDESCRIPTIONWIDGET_H

#include <flydevices_export.h>

#include <QWidget>

#include "device.h"

class QLabel;
class QPushButton;
class QHBoxLayout;

class FLY_DEVICES_EXPORT DeviceDescriptionWidget : public QWidget
{
    Q_OBJECT
public:
    explicit DeviceDescriptionWidget(QWidget *parent = nullptr);
    void setDefaultLabelText(const QString &);

    void setDevice(const Device &device);

    bool showButtons() const;
    void setShowButtons(bool on);

private slots:
    void configureDevice(const QString &type);
    void browseVolume();
    void configureModule();

private:
    QHBoxLayout *prepareButtons();
    void showButtonsForCategory(const QString &category);
    QStringList parseParametersLine(const QString &parametersLine, const Device &device);
    void updateButtonsVisibility();

private:
    QLabel *m_deviceDescription; //Mandatory device page
    Device m_currentDevice;

    QMultiHash<QString, QPushButton *> m_buttonsHash;
    QPushButton *m_moduleConfigButton;

    bool m_showButtons;
};

#endif // DEVICEDESCRIPTIONWIDGET_H
