#ifndef DEVICEPROPERTIESWIDGET2_H
#define DEVICEPROPERTIESWIDGET2_H

#include <flydevices_export.h>

#include <QWidget>

class DevicePropertiesTableModel;
class DevicePropertiesProxyModel;
class Device;

namespace Ui
{
class DevicePropertiesWidget2;
}

class FLY_DEVICES_EXPORT DevicePropertiesWidget2 : public QWidget
{

    Q_OBJECT

public:

    DevicePropertiesWidget2(QWidget * /*parent*/ = nullptr);
    ~DevicePropertiesWidget2();

    const DevicePropertiesTableModel *devicsePropertiesModel() const ;

    bool isCheckable();
    void setCheckable(bool checkable);

    const QSet< QString > &defaultCheckedProperties() const;
    void setDefaultCheckedProperties(const QSet<QString> & /*defaultCheckedProperties*/);

public slots:

    void setDevice(const Device & /*device*/);
    void clear();
    void changeFilter();

protected:

    void loadSettings();
    void saveSettings() const;

protected:

    Ui::DevicePropertiesWidget2 *_ui;
    DevicePropertiesTableModel *_devicePropertiesTableModel;
    DevicePropertiesProxyModel *_devicePropertiesProxyModel;

};

#endif // DEVICEPROPERTIESWIDGET2_H
