#ifndef DEVICETREEWIDGET_H
#define DEVICETREEWIDGET_H

#include <flydevices_export.h>

#include <QTreeWidget>

#include "device.h"

class IBackend;

class FLY_DEVICES_EXPORT DeviceTreeWidget : public QTreeWidget
{
    Q_OBJECT
public:
    explicit DeviceTreeWidget(QWidget *parent = nullptr);

    void getDevices();
    Device currentDevice() const;

    void filterDevices(const QString &filter);

signals:
    void currentDeviceChanged();

private slots:
    void deviceAdded(const Device &device);
    void deviceRemoved(const QString &deviceUdi);
    void deviceChanged(const Device &device);

    void updateCurrentDevice(QTreeWidgetItem *current);

private:
    QTreeWidgetItem *addDevice(const Device &);
    QTreeWidgetItem *addItem(QTreeWidgetItem *, const Device &);
    QTreeWidgetItem *findUpdateDeviceItem(const Device &);

private:
    Device m_currentDevice;
    QHash<QString, QTreeWidgetItem *> m_deviceList;
    QMap<QString, QString> m_replacedUdis;
};

#endif // DEVICETREEWIDGET_H
