#ifndef SETTINGS_DIALOG_H
#define SETTINGS_DIALOG_H

#include <flydevices_export.h>

#include <QDialog>
#include <QMap>

class QFormLayout;
class QAbstractButton;
class QDialogButtonBox;
class QLineEdit;

class FLY_DEVICES_EXPORT SettingsDialog : public QDialog
{
    Q_OBJECT
public:
    SettingsDialog(QWidget *parent = nullptr);
    ~SettingsDialog();

    static QString defaultPropertyValue(const QString &propertyName);
    static QString cmdDescription(const QString &type);

public slots:
    void btnClicked(QAbstractButton *btn);

private:
    static const QMap<QString, QString> defaults_;
    static const QMap<QString, const char *> cmdLabelTexts_;
    static const QMap<QString, const char *> argLabelTexts_;

    QFormLayout *formLt_;
    QDialogButtonBox *bBox_;
    QMap<QString, QLineEdit *> lineEdits_;
};

#endif
